Merge tag 'nfsd-4.6' of git://linux-nfs.org/~bfields/linux
[deliverable/linux.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 #
3 # link vmlinux
4 #
5 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6 # $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8 # Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9 #
10 # vmlinux
11 # ^
12 # |
13 # +-< $(KBUILD_VMLINUX_INIT)
14 # | +--< init/version.o + more
15 # |
16 # +--< $(KBUILD_VMLINUX_MAIN)
17 # | +--< drivers/built-in.o mm/built-in.o + more
18 # |
19 # +-< ${kallsymso} (see description in KALLSYMS section)
20 #
21 # vmlinux version (uname -v) cannot be updated during normal
22 # descending-into-subdirs phase since we do not yet know if we need to
23 # update vmlinux.
24 # Therefore this step is delayed until just before final link of vmlinux.
25 #
26 # System.map is generated to document addresses of all kernel symbols
27
28 # Error out on error
29 set -e
30
31 # Nice output in kbuild format
32 # Will be supressed by "make -s"
33 info()
34 {
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38 }
39
40 # Link of vmlinux.o used for section mismatch analysis
41 # ${1} output file
42 modpost_link()
43 {
44 ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
45 --start-group ${KBUILD_VMLINUX_MAIN} --end-group
46 }
47
48 # Link of vmlinux
49 # ${1} - optional extra .o files
50 # ${2} - output file
51 vmlinux_link()
52 {
53 local lds="${objtree}/${KBUILD_LDS}"
54
55 if [ "${SRCARCH}" != "um" ]; then
56 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
57 -T ${lds} ${KBUILD_VMLINUX_INIT} \
58 --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59 else
60 ${CC} ${CFLAGS_vmlinux} -o ${2} \
61 -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
62 -Wl,--start-group \
63 ${KBUILD_VMLINUX_MAIN} \
64 -Wl,--end-group \
65 -lutil -lrt -lpthread ${1}
66 rm -f linux
67 fi
68 }
69
70
71 # Create ${2} .o file with all symbols from the ${1} object file
72 kallsyms()
73 {
74 info KSYM ${2}
75 local kallsymopt;
76
77 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78 kallsymopt="${kallsymopt} --symbol-prefix=_"
79 fi
80
81 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
82 kallsymopt="${kallsymopt} --all-symbols"
83 fi
84
85 if [ -n "${CONFIG_ARM}" ] && [ -z "${CONFIG_XIP_KERNEL}" ] && [ -n "${CONFIG_PAGE_OFFSET}" ]; then
86 kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
87 fi
88
89 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
90 kallsymopt="${kallsymopt} --absolute-percpu"
91 fi
92
93 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
94 kallsymopt="${kallsymopt} --base-relative"
95 fi
96
97 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
98 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
99
100 ${NM} -n ${1} | \
101 scripts/kallsyms ${kallsymopt} | \
102 ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
103 }
104
105 # Create map file with all symbols from ${1}
106 # See mksymap for additional details
107 mksysmap()
108 {
109 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
110 }
111
112 sortextable()
113 {
114 ${objtree}/scripts/sortextable ${1}
115 }
116
117 # Delete output files in case of error
118 cleanup()
119 {
120 rm -f .old_version
121 rm -f .tmp_System.map
122 rm -f .tmp_kallsyms*
123 rm -f .tmp_version
124 rm -f .tmp_vmlinux*
125 rm -f System.map
126 rm -f vmlinux
127 rm -f vmlinux.o
128 }
129
130 on_exit()
131 {
132 if [ $? -ne 0 ]; then
133 cleanup
134 fi
135 }
136 trap on_exit EXIT
137
138 on_signals()
139 {
140 exit 1
141 }
142 trap on_signals HUP INT QUIT TERM
143
144 #
145 #
146 # Use "make V=1" to debug this script
147 case "${KBUILD_VERBOSE}" in
148 *1*)
149 set -x
150 ;;
151 esac
152
153 if [ "$1" = "clean" ]; then
154 cleanup
155 exit 0
156 fi
157
158 # We need access to CONFIG_ symbols
159 case "${KCONFIG_CONFIG}" in
160 */*)
161 . "${KCONFIG_CONFIG}"
162 ;;
163 *)
164 # Force using a file from the current directory
165 . "./${KCONFIG_CONFIG}"
166 esac
167
168 #link vmlinux.o
169 info LD vmlinux.o
170 modpost_link vmlinux.o
171
172 # modpost vmlinux.o to check for section mismatches
173 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
174
175 # Update version
176 info GEN .version
177 if [ ! -r .version ]; then
178 rm -f .version;
179 echo 1 >.version;
180 else
181 mv .version .old_version;
182 expr 0$(cat .old_version) + 1 >.version;
183 fi;
184
185 # final build of init/
186 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
187
188 kallsymso=""
189 kallsyms_vmlinux=""
190 if [ -n "${CONFIG_KALLSYMS}" ]; then
191
192 # kallsyms support
193 # Generate section listing all symbols and add it into vmlinux
194 # It's a three step process:
195 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
196 # but __kallsyms is empty.
197 # Running kallsyms on that gives us .tmp_kallsyms1.o with
198 # the right size
199 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
200 # the right size, but due to the added section, some
201 # addresses have shifted.
202 # From here, we generate a correct .tmp_kallsyms2.o
203 # 2a) We may use an extra pass as this has been necessary to
204 # woraround some alignment related bugs.
205 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
206 # 3) The correct ${kallsymso} is linked into the final vmlinux.
207 #
208 # a) Verify that the System.map from vmlinux matches the map from
209 # ${kallsymso}.
210
211 kallsymso=.tmp_kallsyms2.o
212 kallsyms_vmlinux=.tmp_vmlinux2
213
214 # step 1
215 vmlinux_link "" .tmp_vmlinux1
216 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
217
218 # step 2
219 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
220 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
221
222 # step 2a
223 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
224 kallsymso=.tmp_kallsyms3.o
225 kallsyms_vmlinux=.tmp_vmlinux3
226
227 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
228
229 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
230 fi
231 fi
232
233 info LD vmlinux
234 vmlinux_link "${kallsymso}" vmlinux
235
236 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
237 info SORTEX vmlinux
238 sortextable vmlinux
239 fi
240
241 info SYSMAP System.map
242 mksysmap vmlinux System.map
243
244 # step a (see comment above)
245 if [ -n "${CONFIG_KALLSYMS}" ]; then
246 mksysmap ${kallsyms_vmlinux} .tmp_System.map
247
248 if ! cmp -s System.map .tmp_System.map; then
249 echo >&2 Inconsistent kallsyms data
250 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
251 exit 1
252 fi
253 fi
254
255 # We made a new kernel - delete old version file
256 rm -f .old_version
This page took 0.035662 seconds and 6 git commands to generate.